パレートスパークライン

パレートスパークラインを使用すると、一式の値の中から最も重要な項目を強調表示できます。

説明
app.js
index.html
styles.css

数式にParetoSparkline関数を使用することで、パレートスパークラインを作成できます。構文は次のとおりです。=PARETOSPARKLINE(points, pointIndex, colorRange?, target?, target2?, highlightPosition?, label?, vertical?, targetColor?, target2Color?, labelColor?, barSize?)

有効なパラメータは次のとおりです。

points: 表示するすべての値を保持するセル範囲を表す参照。「B2:B7」など。

pointIndex: データ点に対応するインデックスを表す数値または参照。1以上の値となります。「1」、「D2」など。

colorRange: (オプション)セグメントボックスの色を保持するセル範囲を表す参照。「D2:D7」など。デフォルト値はnullです。

target: (オプション)目標線の位置を表す数値または参照。「0.5」など。デフォルト値はnullです。

target2: (オプション)第2目標線の位置を表す数値または参照。「0.5」など。デフォルト値はnullです。

highlightPosition: (オプション)赤色で表示するセグメントの順位を表す数値または参照。「3」など。デフォルト値はnullです。

label: (オプション)セグメントのラベルを累積パーセンテージとして表示するのか(label = 1)、単一のパーセンテージとして表示するのか(label = 2)、または表示しないか(label = 0)を表す数値。デフォルト値は「なし(0)」です。

vertical: (オプション)ボックスの向きを垂直方向にするかどうかを表すブール値。デフォルト値はfalseです。

targetColor: (オプション) 目標線の色を表す文字列。

target2Color: (オプション) 第2目標線の色を表す文字列。

labelColor: (オプション) ラベルの前景色を表す文字列。

barSize: (オプション) セルの幅または高さに応じてバーの幅または高さをパーセンテージで表す数値。0から1までの範囲内である必要があります。

数式にParetoSparkline関数を使用することで、パレートスパークラインを作成できます。構文は次のとおりです。=PARETOSPARKLINE(points, pointIndex, colorRange?, target?, target2?, highlightPosition?, label?, vertical?, targetColor?, target2Color?, labelColor?, barSize?) 有効なパラメータは次のとおりです。 points: 表示するすべての値を保持するセル範囲を表す参照。「B2:B7」など。 pointIndex: データ点に対応するインデックスを表す数値または参照。1以上の値となります。「1」、「D2」など。 colorRange: (オプション)セグメントボックスの色を保持するセル範囲を表す参照。「D2:D7」など。デフォルト値はnullです。 target: (オプション)目標線の位置を表す数値または参照。「0.5」など。デフォルト値はnullです。 target2: (オプション)第2目標線の位置を表す数値または参照。「0.5」など。デフォルト値はnullです。 highlightPosition: (オプション)赤色で表示するセグメントの順位を表す数値または参照。「3」など。デフォルト値はnullです。 label: (オプション)セグメントのラベルを累積パーセンテージとして表示するのか(label = 1)、単一のパーセンテージとして表示するのか(label = 2)、または表示しないか(label = 0)を表す数値。デフォルト値は「なし(0)」です。 vertical: (オプション)ボックスの向きを垂直方向にするかどうかを表すブール値。デフォルト値はfalseです。 targetColor: (オプション) 目標線の色を表す文字列。 target2Color: (オプション) 第2目標線の色を表す文字列。 labelColor: (オプション) ラベルの前景色を表す文字列。 barSize: (オプション) セルの幅または高さに応じてバーの幅または高さをパーセンテージで表す数値。0から1までの範囲内である必要があります。
var spreadNS = GC.Spread.Sheets, spread; window.onload = function () { spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 2 }); initSpread(spread); document.getElementById("labelType").addEventListener('change',applyChanges); document.getElementById("highlightPosition").addEventListener('change',applyChanges); document.getElementById("target1").addEventListener('change',applyChanges); document.getElementById("target2").addEventListener('change',applyChanges); document.getElementById("color1").addEventListener('change',applyChanges); document.getElementById("color2").addEventListener('change',applyChanges); }; function applyChanges() { var sheet = spread.getActiveSheet(); var labelType = parseInt(document.getElementById("labelType").value, 10), highlightPosition = parseInt(document.getElementById("highlightPosition").value, 10); if (!isNaN(labelType) && !isNaN(highlightPosition)) { var formulaPart1, formulaPart2; if (spread.getActiveSheetIndex() == 0) { var formula = '=PARETOSPARKLINE($B$3:$B$8,ROW()-2,$C$3:$C$8,'+ document.getElementById('target1').value + ',' + document.getElementById('target2').value +',' + highlightPosition + ','+ labelType +',false,"'+ document.getElementById('color1').value + '","' + document.getElementById('color2').value +'",$C$3:$C$8,$D$3:$D$8)'; for (var i = 2; i <= 7; i++) { sheet.setFormula(i, 4, formula); } } else { var formulaVertical = '=PARETOSPARKLINE($B$3:$G$3,COLUMN()-1,$B$4:$G$4,'+ document.getElementById('target1').value + ',' + document.getElementById('target2').value +',' + highlightPosition + ','+ labelType +',true,"'+ document.getElementById('color1').value + '","' + document.getElementById('color2').value +'",$B$4:$G$4,$B$5:$G$5)'; for (var index = 1; index < 7; index++) { sheet.setFormula(5, index, formulaVertical); } } } } function initSpread(spread) { spread.options.newTabVisible = false; initHorizontalSparkline(spread.sheets[0], "Horizontal"); initVerticalSparkline(spread.sheets[1], "Vertical"); }; function initHorizontalSparkline(sheet, name) { sheet.suspendPaint(); sheet.name(name); sheet.setArray(1, 0, [ ["Reason","Cases","Color","Bar Size","Diagram"], ["Traffic",20,"#CCCCCC",0.1], ["Child care",15,"#82BC00",0.3], ["Public transportation",13,"#F7A711",0.5], ["Weather",6,"#00C2D6",0.7], ["Overslept",4,"#FFE7BA",0.8], ["Emergency",1,"#000000",1] ]); sheet.setValue(10, 0, '*結果:上記のスパークラインより、従業員の遅刻の80%は"traffic"、"child care"、"public transportation"が原因であるという結論になります。'); for (var index = 2; index < 8; index++) { sheet.setFormula(index, 4, '=PARETOSPARKLINE($B$3:$B$8,ROW()-2,$C$3:$C$8,'+ document.getElementById('target1').value + ',' + document.getElementById('target2').value +',0,2,false,"'+ document.getElementById('color1').value + '","' + document.getElementById('color2').value +'",$C$3:$C$8,$D$3:$D$8)'); } //styling for(var i = 1; i<4; i++) { sheet.setColumnWidth(i, 80); } sheet.setColumnWidth(4, 340); sheet.setColumnWidth(0, 140); sheet.setRowHeight(0, 35); sheet.addSpan(0, 0, 1, 5); sheet.getCell(0, 0).value("Late Arrivals by Reported Cause") .font("17px Arial") .vAlign(spreadNS.VerticalAlign.center) .backColor("gray") .foreColor("white"); sheet.getRange(2,0,6,4).hAlign(spreadNS.HorizontalAlign.left); sheet.getRange(1, 0, 1, 5) .font("bold 13px Arial") .setBorder(new spreadNS.LineBorder("black", spreadNS.LineStyle.thin), { bottom: true }); sheet.resumePaint(); } function initVerticalSparkline(sheet, name) { sheet.suspendPaint(); sheet.name(name); sheet.setArray(1, 0, [ ["Reason","Traffic","Child care","Public transportation","Weather","Overslept","Emergency"], ["Cases",20,15,13,5,4,1], ["Color","#CCCCCC","#82BC00","#F7A711","#00C2D6","#FFE7BA","#000000"], ["Bar Size",0.1,0.3,0.5,0.7,0.8,1], ["Diagram"] ]); sheet.setValue(8, 0, '*結果:上記のスパークラインより、従業員の遅刻の80%は"traffic"、"child care"、"public transportation"が原因であるという結論になります。'); for (var index = 1; index < 7; index++) { sheet.setFormula(5, index, '=PARETOSPARKLINE($B$3:$G$3,COLUMN()-1,$B$4:$G$4,'+ document.getElementById('target1').value + ',' + document.getElementById('target2').value +',0,2,true,"'+ document.getElementById('color1').value + '","' + document.getElementById('color2').value +'",$B$4:$G$4,$B$5:$G$5)'); } //styling for(var i = 0; i<7; i++) { sheet.setColumnWidth(i, 120); } sheet.setColumnWidth(3, 150); sheet.setRowHeight(5, 160); sheet.setRowHeight(0, 35); sheet.addSpan(0, 0, 1, 7); sheet.getCell(0, 0).value("Late Arrivals by Reported Cause") .font("17px Arial") .vAlign(spreadNS.VerticalAlign.center) .backColor("gray") .foreColor("white"); sheet.getRange(1, 0, 5, 1) .font("bold 13px Arial") .setBorder(new spreadNS.LineBorder("black", spreadNS.LineStyle.thin), { right: true }); sheet.getRange(1,0,4,7).hAlign(spreadNS.HorizontalAlign.left); sheet.resumePaint(); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta name="spreadjs culture" content="ja-jp" /> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/ja/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/ja/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/ja/purejs/node_modules/@mescius/spread-sheets-resources-ja/dist/gc.spread.sheets.resources.ja.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <div class="option-row"> <label><b>スパークラインの設定:</b></label> </div> <hr> <div class="option-row"> <label for="labelType">ラベルの種類:</label> <select id="labelType"> <option value="0">None</option> <option value="1">Cumulated percentage</option> <option value="2" selected>Single percentage</option> </select> </div> <div class="option-row"> <label for="highlightPosition" >強調表示する項目:</label> <select id="highlightPosition"> <option value="0" selected>None</option> <option value="1">1st</option> <option value="2">2nd</option> <option value="3">3rd</option> <option value="4">4th</option> <option value="5">5th</option> <option value="6">6th</option> </select> </div> <div class="option-row"> <label for="target1">目標線:</label> <input type="text" style="margin: 0 20px 0 6px;width:120px;" id="target1" value="0.5"/> </div> <div class="option-row"> <label for="target2">第2目標線:</label> <input type="text" style="margin: 0 20px 0 6px;width:120px;" id="target2" value="0.8"/> </div> <div class="option-row"> <label for="color1">目標線の色:</label> <select id="color1" style="margin: 0 20px 0 6px"> <option value="#BBBBBB" selected>Grey</option> <option value="#82BC00">Green</option> <option value="#000000">Black</option> <option value="#F7A711">Orange</option> </select> </div> <div class="option-row"> <label for="color2">第2目標線の色:</label> <select id="color2" style="margin: 0 20px 0 6px"> <option value="#BBBBBB">Grey</option> <option value="#82BC00">Green</option> <option value="#000000">Black</option> <option value="#F7A711" selected>Orange</option> </select> </div> </div> </div> </body> </html>
.sample { position: relative; height: 100%; overflow: auto; } .sample::after { display: block; content: ""; clear: both; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } .option-group { margin-bottom: 6px; } input, select { padding: 4px 6px; box-sizing: border-box; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

数式にParetoSparkline関数を使用することで、パレートスパークラインを作成できます。構文は次のとおりです。=PARETOSPARKLINE(points, pointIndex, colorRange?, target?, target2?, highlightPosition?, label?, vertical?, targetColor?, target2Color?, labelColor?, barSize?)
有効なパラメータは次のとおりです。
points: 表示するすべての値を保持するセル範囲を表す参照。「B2:B7」など。
pointIndex: データ点に対応するインデックスを表す数値または参照。1以上の値となります。「1」、「D2」など。
colorRange: (オプション)セグメントボックスの色を保持するセル範囲を表す参照。「D2:D7」など。デフォルト値はnullです。
target: (オプション)目標線の位置を表す数値または参照。「0.5」など。デフォルト値はnullです。
target2: (オプション)第2目標線の位置を表す数値または参照。「0.5」など。デフォルト値はnullです。
highlightPosition: (オプション)赤色で表示するセグメントの順位を表す数値または参照。「3」など。デフォルト値はnullです。
label: (オプション)セグメントのラベルを累積パーセンテージとして表示するのか(label = 1)、単一のパーセンテージとして表示するのか(label = 2)、または表示しないか(label = 0)を表す数値。デフォルト値は「なし(0)」です。
vertical: (オプション)ボックスの向きを垂直方向にするかどうかを表すブール値。デフォルト値はfalseです。
targetColor: (オプション) 目標線の色を表す文字列。
target2Color: (オプション) 第2目標線の色を表す文字列。
labelColor: (オプション) ラベルの前景色を表す文字列。
barSize: (オプション) セルの幅または高さに応じてバーの幅または高さをパーセンテージで表す数値。0から1までの範囲内である必要があります。
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread" :newTabVisible=false>
<gc-worksheet>
</gc-worksheet>
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<label for="labelType">ラベルの種類:</label>
<select id="labelType" v-model="type" v-on:change="applyChanges">
<option value="0">None</option>
<option value="1">Cumulated percentage</option>
<option value="2">Single percentage</option>
</select>
</div>
<div class="option-row">
<label for="highlightPosition">強調表示する項目:</label>
<select id="highlightPosition" v-model="highlight" v-on:change="applyChanges">
<option value="0">None</option>
<option value="1">1st</option>
<option value="2">2nd</option>
<option value="3">3rd</option>
<option value="4">4th</option>
<option value="5">5th</option>
<option value="6">6th</option>
</select>
</div>
<div class="option-row">
<label for="target1">目標線:</label>
<input type="text" v-model="target1" v-on:change="applyChanges" />
</div>
<div class="option-row">
<label for="target2">第2目標線:</label>
<input type="text" v-model="target2" v-on:change="applyChanges" />
</div>
<div class="option-row">
<label for="color1">目標線の色:</label>
<select v-model="color1" v-on:change="applyChanges">
<option value="#BBBBBB" selected>Grey</option>
<option value="#82BC00">Green</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
</select>
</div>
<div class="option-row">
<label for="color2">第2目標線の色:</label>
<select v-model="color2" v-on:change="applyChanges">
<option value="#BBBBBB">Grey</option>
<option value="#82BC00">Green</option>
<option value="#000000">Black</option>
<option value="#F7A711" selected>Orange</option>
</select>
</div>
</div>
</div>
</template>
<script setup>
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
import '@mescius/spread-sheets-vue';
import '@mescius/spread-sheets-resources-ja';
GC.Spread.Common.CultureManager.culture("ja-jp");
const spreadRef = ref(null);
let type = 2;
let highlight = 0;
let target1 = 0.5;
let target2 = 0.8;
let color1 = "#BBBBBB";
let color2 = "#F7A711";
let initHorizontalSparkline = function (sheet, name) {
sheet.suspendPaint();
sheet.name(name);
let spreadNS = GC.Spread.Sheets;
sheet.setArray(1, 0, [
["Reason", "Cases", "Color", "Bar Size", "Diagram"],
["Traffic", 20, "#CCCCCC", 0.1],
["Child care", 15, "#82BC00", 0.3],
["Public transportation", 13, "#F7A711", 0.5],
["Weather", 6, "#00C2D6", 0.7],
["Overslept", 4, "#FFE7BA", 0.8],
["Emergency", 1, "#000000", 1]
]);
sheet.setValue(10, 0, '*結果:上記のスパークラインより、従業員の遅刻の80%は"traffic"、"child care"、"public transportation"が原因であるという結論になります。');
for (var index = 2; index < 8; index++) {
sheet.setFormula(index, 4, '=PARETOSPARKLINE($B$3:$B$8,ROW()-2,$C$3:$C$8,' +
target1 + ',' +
target2 + ',0,2,false,"' +
color1 + '","' +
color2 + '",$C$3:$C$8,$D$3:$D$8)');
}
//styling
for (var i = 1; i < 4; i++) {
sheet.setColumnWidth(i, 80);
}
sheet.setColumnWidth(4, 340);
sheet.setColumnWidth(0, 140);
sheet.setRowHeight(0, 35);
sheet.addSpan(0, 0, 1, 5);
sheet.getCell(0, 0).value("Late Arrivals by Reported Cause")
.font("17px Arial")
.vAlign(spreadNS.VerticalAlign.center)
.backColor("gray")
.foreColor("white");
sheet.getRange(2, 0, 6, 4).hAlign(spreadNS.HorizontalAlign.left);
sheet.getRange(1, 0, 1, 5)
.font("bold 13px Arial")
.setBorder(new spreadNS.LineBorder("black", spreadNS.LineStyle.thin), { bottom: true });
sheet.resumePaint();
}
let initVerticalSparkline = function (sheet, name) {
let spreadNS = GC.Spread.Sheets;
sheet.suspendPaint();
sheet.name(name);
sheet.setArray(1, 0, [
["Reason", "Traffic", "Child care", "Public transportation", "Weather", "Overslept", "Emergency"],
["Cases", 20, 15, 13, 5, 4, 1],
["Color", "#CCCCCC", "#82BC00", "#F7A711", "#00C2D6", "#FFE7BA", "#000000"],
["Bar Size", 0.1, 0.3, 0.5, 0.7, 0.8, 1],
["Diagram"]
]);
sheet.setValue(8, 0, '*結果:上記のスパークラインより、従業員の遅刻の80%は"traffic"、"child care"、"public transportation"が原因であるという結論になります。');
for (var index = 1; index < 7; index++) {
sheet.setFormula(5, index, '=PARETOSPARKLINE($B$3:$G$3,COLUMN()-1,$B$4:$G$4,' +
target1 + ',' +
target2 + ',0,2,true,"' +
color1 + '","' +
color2 + '",$B$4:$G$4,$B$5:$G$5)');
}
//styling
for (var i = 0; i < 7; i++) {
sheet.setColumnWidth(i, 120);
}
sheet.setColumnWidth(3, 150);
sheet.setRowHeight(5, 160);
sheet.setRowHeight(0, 35);
sheet.addSpan(0, 0, 1, 7);
sheet.getCell(0, 0).value("Late Arrivals by Reported Cause")
.font("17px Arial")
.vAlign(spreadNS.VerticalAlign.center)
.backColor("gray")
.foreColor("white");
sheet.getRange(1, 0, 5, 1)
.font("bold 13px Arial")
.setBorder(new spreadNS.LineBorder("black", spreadNS.LineStyle.thin), { right: true });
sheet.getRange(1, 0, 4, 7).hAlign(spreadNS.HorizontalAlign.left);
sheet.resumePaint();
}
let applyChanges = function () {
let spread = spreadRef.value;
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
let labelType = parseInt(type, 10),
highlightPosition = parseInt(highlight, 10);
if (spread.getActiveSheetIndex() == 0) {
var formula = '=PARETOSPARKLINE($B$3:$B$8,ROW()-2,$C$3:$C$8,' +
target1 + ',' +
target2 + ',' + highlightPosition + ',' + labelType + ',false,"' +
color1 + '","' +
color2 + '",$C$3:$C$8,$D$3:$D$8)';
for (var i = 2; i <= 7; i++) {
sheet.setFormula(i, 4, formula);
}
} else {
var formulaVertical = '=PARETOSPARKLINE($B$3:$G$3,COLUMN()-1,$B$4:$G$4,' +
target1 + ',' +
target2 + ',' + highlightPosition + ',' + labelType + ',true,"' +
color1 + '","' +
color2 + '",$B$4:$G$4,$B$5:$G$5)';
for (var index = 1; index < 7; index++) {
sheet.setFormula(5, index, formulaVertical);
}
}
sheet.resumePaint();
}
let initSpread = function (spread) {
spreadRef.value = spread;
initHorizontalSparkline(spread.sheets[0], "Horizontal");
initVerticalSparkline(spread.sheets[1], "Vertical");
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample {
position: relative;
height: 100%;
overflow: auto;
}
.sample::after {
display: block;
content: "";
clear: both;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 8px;
}
input,
select {
margin-top: 6px;
width: 100%;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html lang="en" style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/ja/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/ja/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/ja/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

数式にParetoSparkline関数を使用することで、パレートスパークラインを作成できます。構文は次のとおりです。=PARETOSPARKLINE(points, pointIndex, colorRange?, target?, target2?, highlightPosition?, label?, vertical?, targetColor?, target2Color?, labelColor?, barSize?)
有効なパラメータは次のとおりです。
points: 表示するすべての値を保持するセル範囲を表す参照。「B2:B7」など。
pointIndex: データ点に対応するインデックスを表す数値または参照。1以上の値となります。「1」、「D2」など。
colorRange: (オプション)セグメントボックスの色を保持するセル範囲を表す参照。「D2:D7」など。デフォルト値はnullです。
target: (オプション)目標線の位置を表す数値または参照。「0.5」など。デフォルト値はnullです。
target2: (オプション)第2目標線の位置を表す数値または参照。「0.5」など。デフォルト値はnullです。
highlightPosition: (オプション)赤色で表示するセグメントの順位を表す数値または参照。「3」など。デフォルト値はnullです。
label: (オプション)セグメントのラベルを累積パーセンテージとして表示するのか(label = 1)、単一のパーセンテージとして表示するのか(label = 2)、または表示しないか(label = 0)を表す数値。デフォルト値は「なし(0)」です。
vertical: (オプション)ボックスの向きを垂直方向にするかどうかを表すブール値。デフォルト値はfalseです。
targetColor: (オプション) 目標線の色を表す文字列。
target2Color: (オプション) 第2目標線の色を表す文字列。
labelColor: (オプション) ラベルの前景色を表す文字列。
barSize: (オプション) セルの幅または高さに応じてバーの幅または高さをパーセンテージで表す数値。0から1までの範囲内である必要があります。
import { Component, NgModule, enableProdMode } from '@angular/core';
import { bootstrapApplication, BrowserModule } from '@angular/platform-browser';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ja';
GC.Spread.Common.CultureManager.culture("ja-jp");
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import './styles.css';
@Component({
standalone: true,
imports: [SpreadSheetsModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
type = 2;
highlight = 0;
target1 = 0.5;
target2=0.8;
color1="#BBBBBB";
color2="#F7A711";
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
highlightChange(e: any) {
let value = parseInt(e.target.value);
this.highlight = value;
this.applyChanges();
}
typeChanges(e: any) {
let value = parseInt(e.target.value);
this.type = value;
this.applyChanges();
}
target1Change(e: any) {
this.target1 = e.target.value;
this.applyChanges();
}
target2Change(e: any) {
this.target2 = e.target.value;
this.applyChanges();
}
color1Change(e: any) {
this.color1 = e.target.value;
this.applyChanges();
}
color2Change(e: any) {
this.color2 = e.target.value;
this.applyChanges();
}
initHorizontalSparkline(sheet: GC.Spread.Sheets.Worksheet, name: string) {
sheet.suspendPaint();
sheet.name(name);
let spreadNS = GC.Spread.Sheets;
sheet.setArray(1, 0, [
["Reason","Cases","Color","Bar Size","Diagram"],
["Traffic",20,"#CCCCCC",0.1],
["Child care",15,"#82BC00",0.3],
["Public transportation",13,"#F7A711",0.5],
["Weather",6,"#00C2D6",0.7],
["Overslept",4,"#FFE7BA",0.8],
["Emergency",1,"#000000",1]
]);
sheet.setValue(10, 0, '*結果:上記のスパークラインより、従業員の遅刻の80%は"traffic"、"child care"、"public transportation"が原因であるという結論になります。');
for (var index = 2; index < 8; index++) {
sheet.setFormula(index, 4, '=PARETOSPARKLINE($B$3:$B$8,ROW()-2,$C$3:$C$8,'+
this.target1 + ',' +
this.target2 +',0,2,false,"'+
this.color1 + '","' +
this.color2 +'",$C$3:$C$8,$D$3:$D$8)');
}
//styling
for(var i = 1; i<4; i++)
{
sheet.setColumnWidth(i, 80);
}
sheet.setColumnWidth(4, 340);
sheet.setColumnWidth(0, 140);
sheet.setRowHeight(0, 35);
sheet.addSpan(0, 0, 1, 5);
sheet.getCell(0, 0).value("Late Arrivals by Reported Cause")
.font("17px Arial")
.vAlign(spreadNS.VerticalAlign.center)
.backColor("gray")
.foreColor("white");
sheet.getRange(2,0,6,4).hAlign(spreadNS.HorizontalAlign.left);
sheet.getRange(1, 0, 1, 5)
.font("bold 13px Arial")
.setBorder(new spreadNS.LineBorder("black", spreadNS.LineStyle.thin), { bottom: true });
sheet.resumePaint();
}
initVerticalSparkline(sheet: GC.Spread.Sheets.Worksheet, name: string) {
let spreadNS = GC.Spread.Sheets;
sheet.suspendPaint();
sheet.name(name);
sheet.setArray(1, 0, [
["Reason","Traffic","Child care","Public transportation","Weather","Overslept","Emergency"],
["Cases",20,15,13,5,4,1],
["Color","#CCCCCC","#82BC00","#F7A711","#00C2D6","#FFE7BA","#000000"],
["Bar Size",0.1,0.3,0.5,0.7,0.8,1],
["Diagram"]
]);
sheet.setValue(8, 0, '*結果:上記のスパークラインより、従業員の遅刻の80%は"traffic"、"child care"、"public transportation"が原因であるという結論になります。');
for (var index = 1; index < 7; index++) {
sheet.setFormula(5, index, '=PARETOSPARKLINE($B$3:$G$3,COLUMN()-1,$B$4:$G$4,'+
this.target1+ ',' +
this.target2 +',0,2,true,"'+
this.color1 + '","' +
this.color2 +'",$B$4:$G$4,$B$5:$G$5)');
}
//styling
for(var i = 0; i<7; i++)
{
sheet.setColumnWidth(i, 120);
}
sheet.setColumnWidth(3, 150);
sheet.setRowHeight(5, 160);
sheet.setRowHeight(0, 35);
sheet.addSpan(0, 0, 1, 7);
sheet.getCell(0, 0).value("Late Arrivals by Reported Cause")
.font("17px Arial")
.vAlign(spreadNS.VerticalAlign.center)
.backColor("gray")
.foreColor("white");
sheet.getRange(1, 0, 5, 1)
.font("bold 13px Arial")
.setBorder(new spreadNS.LineBorder("black", spreadNS.LineStyle.thin), { right: true });
sheet.getRange(1,0,4,7).hAlign(spreadNS.HorizontalAlign.left);
sheet.resumePaint();
}
applyChanges() {
let sheet = this.spread.getActiveSheet();
let labelType = this.type,
highlightPosition = this.highlight;
if (!isNaN(labelType) && !isNaN(highlightPosition)) {
if (this.spread.getActiveSheetIndex() == 0) {
var formula = '=PARETOSPARKLINE($B$3:$B$8,ROW()-2,$C$3:$C$8,'+
this.target1 + ',' +
this.target2 +',' + highlightPosition + ','+ labelType +',false,"'+
this.color1 + '","' +
this.color2 +'",$C$3:$C$8,$D$3:$D$8)';
for (var i = 2; i <= 7; i++) {
sheet.setFormula(i, 4, formula);
}
} else {
var formulaVertical = '=PARETOSPARKLINE($B$3:$G$3,COLUMN()-1,$B$4:$G$4,'+
this.target1 + ',' +
this.target2 +',' + highlightPosition + ','+ labelType +',true,"'+
this.color1 + '","' +
this.color2 +'",$B$4:$G$4,$B$5:$G$5)';
for (var index = 1; index < 7; index++) {
sheet.setFormula(5, index, formulaVertical);
}
}
}
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
this.initHorizontalSparkline(spread.sheets[0], "Horizontal");
this.initVerticalSparkline(spread.sheets[1], "Vertical");
}
}
enableProdMode();
bootstrapApplication(AppComponent);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ja/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/ja/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/ja/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/ja/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/ja/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)" [newTabVisible] = false>
<gc-worksheet>
</gc-worksheet>
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<label><b>スパークラインの設定:</b></label>
</div>
<hr>
<div class="option-row">
<label for="labelType">ラベルの種類:</label>
<select id="labelType" [value]="type" (change) = "typeChanges($event)">
<option value="0">None</option>
<option value="1">Cumulated percentage</option>
<option value="2">Single percentage</option>
</select>
</div>
<div class="option-row">
<label for="highlightPosition" >強調表示する項目:</label>
<select id="highlightPosition" [value]="highlight" (change) = "highlightChange($event)">
<option value="0">None</option>
<option value="1">1st</option>
<option value="2">2nd</option>
<option value="3">3rd</option>
<option value="4">4th</option>
<option value="5">5th</option>
<option value="6">6th</option>
</select>
</div>
<div class="option-row">
<label for="target1">目標線:</label>
<input type="text" style="margin: 0 20px 0 6px;width:120px;" id="target1" (change) = "target1Change($event)" value="0.5"/>
</div>
<div class="option-row">
<label for="target2">第2目標線:</label>
<input type="text" style="margin: 0 20px 0 6px;width:120px;" id="target2" (change) = "target2Change($event)" value="0.8"/>
</div>
<div class="option-row">
<label for="color1">目標線の色:</label>
<select id="color1" style="margin: 0 20px 0 6px" (change) = "color1Change($event)" >
<option value="#BBBBBB" selected>Grey</option>
<option value="#82BC00">Green</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
</select>
</div>
<div class="option-row">
<label for="color2">第2目標線の色:</label>
<select id="color2" style="margin: 0 20px 0 6px" (change) = "color2Change($event)" >
<option value="#BBBBBB">Grey</option>
<option value="#82BC00">Green</option>
<option value="#000000">Black</option>
<option value="#F7A711" selected>Orange</option>
</select>
</div>
</div>
</div>
.sample {
position: relative;
height: 100%;
overflow: auto;
}
.sample::after {
display: block;
content: "";
clear: both;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 12px;
}
input,
select {
padding: 4px 6px;
box-sizing: border-box;
}
p{
padding:2px 10px;
background-color:#F4F8EB;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'tslib':'npm:tslib/tslib.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts',
meta: {
"*.component.ts": {
loader: "system.component-loader.js"
}
}
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

数式にParetoSparkline関数を使用することで、パレートスパークラインを作成できます。構文は次のとおりです。=PARETOSPARKLINE(points, pointIndex, colorRange?, target?, target2?, highlightPosition?, label?, vertical?, targetColor?, target2Color?, labelColor?, barSize?)
有効なパラメータは次のとおりです。
points: 表示するすべての値を保持するセル範囲を表す参照。「B2:B7」など。
pointIndex: データ点に対応するインデックスを表す数値または参照。1以上の値となります。「1」、「D2」など。
colorRange: (オプション)セグメントボックスの色を保持するセル範囲を表す参照。「D2:D7」など。デフォルト値はnullです。
target: (オプション)目標線の位置を表す数値または参照。「0.5」など。デフォルト値はnullです。
target2: (オプション)第2目標線の位置を表す数値または参照。「0.5」など。デフォルト値はnullです。
highlightPosition: (オプション)赤色で表示するセグメントの順位を表す数値または参照。「3」など。デフォルト値はnullです。
label: (オプション)セグメントのラベルを累積パーセンテージとして表示するのか(label = 1)、単一のパーセンテージとして表示するのか(label = 2)、または表示しないか(label = 0)を表す数値。デフォルト値は「なし(0)」です。
vertical: (オプション)ボックスの向きを垂直方向にするかどうかを表すブール値。デフォルト値はfalseです。
targetColor: (オプション) 目標線の色を表す文字列。
target2Color: (オプション) 第2目標線の色を表す文字列。
labelColor: (オプション) ラベルの前景色を表す文字列。
barSize: (オプション) セルの幅または高さに応じてバーの幅または高さをパーセンテージで表す数値。0から1までの範囲内である必要があります。
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ja';
GC.Spread.Common.CultureManager.culture("ja-jp");
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
let spread = null;
export function AppFunc() {
const [paretoOption, setParetoOption] = React.useState({
type: 2,
highlight: 0,
target1: 0.5,
target2: 0.8,
color1: "#BBBBBB",
color2: "#F7A711"
});
React.useEffect(() => {
applyChanges();
}, [paretoOption]);
const highlightChange = (e) => {
let value = parseInt(e.target.value);
setParetoOption({
...paretoOption,
highlight: value
});
}
const typeChanges = (e) => {
let value = parseInt(e.target.value);
setParetoOption({
...paretoOption,
type: value
});
}
const target1Change = (e) => {
let value = e.target.value;
setParetoOption({
...paretoOption,
target1: value
});
}
const target2Change = (e) => {
let value = e.target.value;
setParetoOption({
...paretoOption,
target2: value
});
}
const color1Change = (e) => {
let value = e.target.value;
setParetoOption({
...paretoOption,
color1: value
});
}
const color2Change = (e) => {
let value = e.target.value;
setParetoOption({
...paretoOption,
color2: value
});
}
const initHorizontalSparkline = (sheet, name) => {
sheet.suspendPaint();
sheet.name(name);
let spreadNS = GC.Spread.Sheets;
sheet.setArray(1, 0, [
["Reason", "Cases", "Color", "Bar Size", "Diagram"],
["Traffic", 20, "#CCCCCC", 0.1],
["Child care", 15, "#82BC00", 0.3],
["Public transportation", 13, "#F7A711", 0.5],
["Weather", 6, "#00C2D6", 0.7],
["Overslept", 4, "#FFE7BA", 0.8],
["Emergency", 1, "#000000", 1]
]);
sheet.setValue(10, 0, '*結果:上記のスパークラインより、従業員の遅刻の80%は"traffic"、"child care"、"public transportation"が原因であるという結論になります。');
for (var index = 2; index < 8; index++) {
sheet.setFormula(index, 4, '=PARETOSPARKLINE($B$3:$B$8,ROW()-2,$C$3:$C$8,' +
paretoOption.target1 + ',' +
paretoOption.target2 + ',0,2,false,"' +
paretoOption.color1 + '","' +
paretoOption.color2 + '",$C$3:$C$8,$D$3:$D$8)');
}
//styling
for (var i = 1; i < 4; i++) {
sheet.setColumnWidth(i, 80);
}
sheet.setColumnWidth(4, 340);
sheet.setColumnWidth(0, 140);
sheet.setRowHeight(0, 35);
sheet.addSpan(0, 0, 1, 5);
sheet.getCell(0, 0).value("Late Arrivals by Reported Cause")
.font("17px Arial")
.vAlign(spreadNS.VerticalAlign.center)
.backColor("gray")
.foreColor("white");
sheet.getRange(2, 0, 6, 4).hAlign(spreadNS.HorizontalAlign.left);
sheet.getRange(1, 0, 1, 5)
.font("bold 13px Arial")
.setBorder(new spreadNS.LineBorder("black", spreadNS.LineStyle.thin), { bottom: true });
sheet.resumePaint();
}
const initVerticalSparkline = (sheet, name) => {
let spreadNS = GC.Spread.Sheets;
sheet.suspendPaint();
sheet.name(name);
sheet.setArray(1, 0, [
["Reason", "Traffic", "Child care", "Public transportation", "Weather", "Overslept", "Emergency"],
["Cases", 20, 15, 13, 5, 4, 1],
["Color", "#CCCCCC", "#82BC00", "#F7A711", "#00C2D6", "#FFE7BA", "#000000"],
["Bar Size", 0.1, 0.3, 0.5, 0.7, 0.8, 1],
["Diagram"]
]);
sheet.setValue(8, 0, '*結果:上記のスパークラインより、従業員の遅刻の80%は"traffic"、"child care"、"public transportation"が原因であるという結論になります。');
for (var index = 1; index < 7; index++) {
sheet.setFormula(5, index, '=PARETOSPARKLINE($B$3:$G$3,COLUMN()-1,$B$4:$G$4,' +
paretoOption.target1 + ',' +
paretoOption.target2 + ',0,2,true,"' +
paretoOption.color1 + '","' +
paretoOption.color2 + '",$B$4:$G$4,$B$5:$G$5)');
}
//styling
for (var i = 0; i < 7; i++) {
sheet.setColumnWidth(i, 120);
}
sheet.setColumnWidth(3, 150);
sheet.setRowHeight(5, 160);
sheet.setRowHeight(0, 35);
sheet.addSpan(0, 0, 1, 7);
sheet.getCell(0, 0).value("Late Arrivals by Reported Cause")
.font("17px Arial")
.vAlign(spreadNS.VerticalAlign.center)
.backColor("gray")
.foreColor("white");
sheet.getRange(1, 0, 5, 1)
.font("bold 13px Arial")
.setBorder(new spreadNS.LineBorder("black", spreadNS.LineStyle.thin), { right: true });
sheet.getRange(1, 0, 4, 7).hAlign(spreadNS.HorizontalAlign.left);
sheet.resumePaint();
}
const applyChanges = () => {
let sheet = spread.getActiveSheet();
let labelType = parseInt(paretoOption.type, 10),
highlightPosition = parseInt(paretoOption.highlight, 10);
if (spread.getActiveSheetIndex() == 0) {
var formula = '=PARETOSPARKLINE($B$3:$B$8,ROW()-2,$C$3:$C$8,' +
paretoOption.target1 + ',' +
paretoOption.target2 + ',' + highlightPosition + ',' + labelType + ',false,"' +
paretoOption.color1 + '","' +
paretoOption.color2 + '",$C$3:$C$8,$D$3:$D$8)';
for (var i = 2; i <= 7; i++) {
sheet.setFormula(i, 4, formula);
}
} else {
var formulaVertical = '=PARETOSPARKLINE($B$3:$G$3,COLUMN()-1,$B$4:$G$4,' +
paretoOption.target1 + ',' +
paretoOption.target2 + ',' + highlightPosition + ',' + labelType + ',true,"' +
paretoOption.color1 + '","' +
paretoOption.color2 + '",$B$4:$G$4,$B$5:$G$5)';
for (var index = 1; index < 7; index++) {
sheet.setFormula(5, index, formulaVertical);
}
}
}
const initSpread = (currSpread) => {
spread = currSpread;
initHorizontalSparkline(spread.sheets[0], "Horizontal");
initVerticalSparkline(spread.sheets[1], "Vertical");
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)} newTabVisible={false}>
<Worksheet>
</Worksheet>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel panelInfo={paretoOption}
typeChanges={(e) => { typeChanges(e) }}
highlightChange={(e) => { highlightChange(e) }}
target1Change={(e) => { target1Change(e) }}
target2Change={(e) => { target2Change(e) }}
color1Change={(e) => { color1Change(e) }}
color2Change={(e) => { color2Change(e) }}
/>
</div>
);
}
const Panel = (props) => {
const { panelInfo, highlightChange, typeChanges, target1Change, target2Change, color1Change, color2Change } = props;
return (
<div class="options-container">
<div class="option-row">
<label><b>スパークラインの設定</b></label>
</div>
<hr />
<div class="option-row">
<label for="labelType">ラベルの種類:</label>
<select id="labelType" value={panelInfo.type + ""} onChange={(e) => { typeChanges(e) }}>
<option value="0">None</option>
<option value="1">Cumulated percentage</option>
<option value="2" selected>Single percentage</option>
</select>
</div>
<div class="option-row">
<label for="highlightPosition" >強調表示する項目:</label>
<select id="highlightPosition" value={panelInfo.highlight + ""} onChange={(e) => { highlightChange(e) }}>
<option value="0" selected>None</option>
<option value="1">1st</option>
<option value="2">2nd</option>
<option value="3">3rd</option>
<option value="4">4th</option>
<option value="5">5th</option>
<option value="6">6th</option>
</select>
</div>
<div class="option-row">
<label for="target1">目標線:</label>
<input type="text" value={panelInfo.target1 + ""} onChange={(e) => { target1Change(e) }} />
</div>
<div class="option-row">
<label for="target2">第2目標線:</label>
<input type="text" value={panelInfo.target2 + ""} onChange={(e) => { target2Change(e) }} />
</div>
<div class="option-row">
<label for="color1">目標線の色:</label>
<select value={panelInfo.color1 + ""} onChange={(e) => { color1Change(e) }}>
<option value="#BBBBBB" selected>Grey</option>
<option value="#82BC00">Green</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
</select>
</div>
<div class="option-row">
<label for="color2">第2目標線の色:</label>
<select value={panelInfo.color2 + ""} onChange={(e) => { color2Change(e) }}>
<option value="#BBBBBB">Grey</option>
<option value="#82BC00">Green</option>
<option value="#000000">Black</option>
<option value="#F7A711" selected>Orange</option>
</select>
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
const PureComponent = React.PureComponent;
export class App extends PureComponent {
constructor(props) {
super(props);
this.spread = null;
this.state = {
type: 2,
highlight: 0,
target1: 0.5,
target2: 0.8,
color1: "#BBBBBB",
color2: "#F7A711"
};
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)} newTabVisible={false}>
<Worksheet>
</Worksheet>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel panelInfo={this.state}
typeChanges={(e) => { this.typeChanges(e) }}
highlightChange={(e) => { this.highlightChange(e) }}
target1Change={(e) => { this.target1Change(e) }}
target2Change={(e) => { this.target2Change(e) }}
color1Change={(e) => { this.color1Change(e) }}
color2Change={(e) => { this.color2Change(e) }}
/>
</div>
)
}
highlightChange(e) {
let value = parseInt(e.target.value);
this.setState(() => ({
highlight: value
}), () => {
this.applyChanges();
})
}
typeChanges(e) {
let value = parseInt(e.target.value);
this.setState(() => ({
type: value
}), () => {
this.applyChanges();
})
}
target1Change(e) {
let value = e.target.value;
this.setState(() => ({
target1: value
}), () => {
this.applyChanges();
})
}
target2Change(e) {
let value = e.target.value;
this.setState(() => ({
target2: value
}), () => {
this.applyChanges();
})
}
color1Change(e) {
let value = e.target.value;
this.setState(() => ({
color1: value
}), () => {
this.applyChanges();
})
}
color2Change(e) {
let value = e.target.value;
this.setState(() => ({
color2: value
}), () => {
this.applyChanges();
})
}
initHorizontalSparkline(sheet, name) {
sheet.suspendPaint();
sheet.name(name);
let spreadNS = GC.Spread.Sheets;
sheet.setArray(1, 0, [
["Reason", "Cases", "Color", "Bar Size", "Diagram"],
["Traffic", 20, "#CCCCCC", 0.1],
["Child care", 15, "#82BC00", 0.3],
["Public transportation", 13, "#F7A711", 0.5],
["Weather", 6, "#00C2D6", 0.7],
["Overslept", 4, "#FFE7BA", 0.8],
["Emergency", 1, "#000000", 1]
]);
sheet.setValue(10, 0, '*結果:上記のスパークラインより、従業員の遅刻の80%は"traffic"、"child care"、"public transportation"が原因であるという結論になります。');
for (var index = 2; index < 8; index++) {
sheet.setFormula(index, 4, '=PARETOSPARKLINE($B$3:$B$8,ROW()-2,$C$3:$C$8,' +
this.state.target1 + ',' +
this.state.target2 + ',0,2,false,"' +
this.state.color1 + '","' +
this.state.color2 + '",$C$3:$C$8,$D$3:$D$8)');
}
//styling
for (var i = 1; i < 4; i++) {
sheet.setColumnWidth(i, 80);
}
sheet.setColumnWidth(4, 340);
sheet.setColumnWidth(0, 140);
sheet.setRowHeight(0, 35);
sheet.addSpan(0, 0, 1, 5);
sheet.getCell(0, 0).value("Late Arrivals by Reported Cause")
.font("17px Arial")
.vAlign(spreadNS.VerticalAlign.center)
.backColor("gray")
.foreColor("white");
sheet.getRange(2, 0, 6, 4).hAlign(spreadNS.HorizontalAlign.left);
sheet.getRange(1, 0, 1, 5)
.font("bold 13px Arial")
.setBorder(new spreadNS.LineBorder("black", spreadNS.LineStyle.thin), { bottom: true });
sheet.resumePaint();
}
initVerticalSparkline(sheet, name) {
let spreadNS = GC.Spread.Sheets;
sheet.suspendPaint();
sheet.name(name);
sheet.setArray(1, 0, [
["Reason", "Traffic", "Child care", "Public transportation", "Weather", "Overslept", "Emergency"],
["Cases", 20, 15, 13, 5, 4, 1],
["Color", "#CCCCCC", "#82BC00", "#F7A711", "#00C2D6", "#FFE7BA", "#000000"],
["Bar Size", 0.1, 0.3, 0.5, 0.7, 0.8, 1],
["Diagram"]
]);
sheet.setValue(8, 0, '*結果:上記のスパークラインより、従業員の遅刻の80%は"traffic"、"child care"、"public transportation"が原因であるという結論になります。');
for (var index = 1; index < 7; index++) {
sheet.setFormula(5, index, '=PARETOSPARKLINE($B$3:$G$3,COLUMN()-1,$B$4:$G$4,' +
this.state.target1 + ',' +
this.state.target2 + ',0,2,true,"' +
this.state.color1 + '","' +
this.state.color2 + '",$B$4:$G$4,$B$5:$G$5)');
}
//styling
for (var i = 0; i < 7; i++) {
sheet.setColumnWidth(i, 120);
}
sheet.setColumnWidth(3, 150);
sheet.setRowHeight(5, 160);
sheet.setRowHeight(0, 35);
sheet.addSpan(0, 0, 1, 7);
sheet.getCell(0, 0).value("Late Arrivals by Reported Cause")
.font("17px Arial")
.vAlign(spreadNS.VerticalAlign.center)
.backColor("gray")
.foreColor("white");
sheet.getRange(1, 0, 5, 1)
.font("bold 13px Arial")
.setBorder(new spreadNS.LineBorder("black", spreadNS.LineStyle.thin), { right: true });
sheet.getRange(1, 0, 4, 7).hAlign(spreadNS.HorizontalAlign.left);
sheet.resumePaint();
}
applyChanges() {
let sheet = this.spread.getActiveSheet();
let labelType = parseInt(this.state.type, 10),
highlightPosition = parseInt(this.state.highlight, 10);
if (this.spread.getActiveSheetIndex() == 0) {
var formula = '=PARETOSPARKLINE($B$3:$B$8,ROW()-2,$C$3:$C$8,' +
this.state.target1 + ',' +
this.state.target2 + ',' + highlightPosition + ',' + labelType + ',false,"' +
this.state.color1 + '","' +
this.state.color2 + '",$C$3:$C$8,$D$3:$D$8)';
for (var i = 2; i <= 7; i++) {
sheet.setFormula(i, 4, formula);
}
} else {
var formulaVertical = '=PARETOSPARKLINE($B$3:$G$3,COLUMN()-1,$B$4:$G$4,' +
this.state.target1 + ',' +
this.state.target2 + ',' + highlightPosition + ',' + labelType + ',true,"' +
this.state.color1 + '","' +
this.state.color2 + '",$B$4:$G$4,$B$5:$G$5)';
for (var index = 1; index < 7; index++) {
sheet.setFormula(5, index, formulaVertical);
}
}
}
initSpread(spread) {
this.spread = spread;
this.initHorizontalSparkline(spread.sheets[0], "Horizontal");
this.initVerticalSparkline(spread.sheets[1], "Vertical");
}
}
const Panel = (props) => {
const { panelInfo, highlightChange, typeChanges, target1Change, target2Change, color1Change, color2Change } = props;
return (
<div class="options-container">
<div class="option-row">
<label><b>スパークラインの設定:</b></label>
</div>
<hr />
<div class="option-row">
<label for="labelType">ラベルの種類:</label>
<select id="labelType" value={panelInfo.type + ""} onChange={(e) => { typeChanges(e) }}>
<option value="0">None</option>
<option value="1">Cumulated percentage</option>
<option value="2" selected>Single percentage</option>
</select>
</div>
<div class="option-row">
<label for="highlightPosition" >強調表示する項目:</label>
<select id="highlightPosition" value={panelInfo.highlight + ""} onChange={(e) => { highlightChange(e) }}>
<option value="0" selected>None</option>
<option value="1">1st</option>
<option value="2">2nd</option>
<option value="3">3rd</option>
<option value="4">4th</option>
<option value="5">5th</option>
<option value="6">6th</option>
</select>
</div>
<div class="option-row">
<label for="target1">目標線:</label>
<input type="text" value={panelInfo.target1 + ""} onChange={(e) => { target1Change(e) }} />
</div>
<div class="option-row">
<label for="target2">第2目標線:</label>
<input type="text" value={panelInfo.target2 + ""} onChange={(e) => { target2Change(e) }} />
</div>
<div class="option-row">
<label for="color1">目標線の色:</label>
<select value={panelInfo.color1 + ""} onChange={(e) => { color1Change(e) }}>
<option value="#BBBBBB" selected>Grey</option>
<option value="#82BC00">Green</option>
<option value="#000000">Black</option>
<option value="#F7A711">Orange</option>
</select>
</div>
<div class="option-row">
<label for="color2">第2目標線の色:</label>
<select value={panelInfo.color2 + ""} onChange={(e) => { color2Change(e) }}>
<option value="#BBBBBB">Grey</option>
<option value="#82BC00">Green</option>
<option value="#000000">Black</option>
<option value="#F7A711" selected>Orange</option>
</select>
</div>
</div>
);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ja/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/ja/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/ja/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample {
position: relative;
height: 100%;
overflow: auto;
}
.sample::after {
display: block;
content: "";
clear: both;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 6px;
}
label {
display: inline-block;
min-width: 90px;
margin-bottom: 6px;
}
select {
padding: 4px 6px;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);